<template>
    <q-page class="bg-base">
        <DocumentWrapper ref="wrap">
            <WorkerFullCard
                v-if="$q.screen.lg"
                :worker="worker"
                @delete="dialog = true"
                @edit="Edit"
            />
            <WorkerMobile v-else
                          :worker="worker"
                          @delete="dialog = true"
                          @edit="Edit"/>
            <q-dialog v-model="dialog" persistent>
                <DeleteWorkerDialog v-if="worker != null" @back="dialog = false" :sub="routeParams.subId" @delete="Delete" class="bg-base" :worker="worker.principal"/>
            </q-dialog>
        </DocumentWrapper>
    </q-page>
</template>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import {WorkerResponse} from "src/classLibrary/APIModels/core/workerResponse";
import WorkerFullCard from "components/Full/WorkerFullCard.vue";
import DeleteWorkerDialog from "components/Dialog/DeleteWorkerDialog.vue";
import WorkerMobile from "components/Full/WorkerMobile.vue";

@Component({
    components: {WorkerMobile, DeleteWorkerDialog, WorkerFullCard, DocumentWrapper}
})
export default class WorkerIndex extends Vue {
    routeParams = {
        subId: '',
        workerId: '',
    }
    worker: WorkerResponse | null = null;
    dialog = false;

    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    Edit() {

    }

    async Delete() {
        await this.$router.push(`/subcontractor/${this.routeParams.subId}`);
    }


    async loadWorker() {
        const token = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<WorkerResponse>(`Worker/${this.routeParams.subId}/${this.routeParams.workerId}`, null, token);
        if (r.isErr()) {
            return this.Wrap.SubmitError(r.unwrapErr())
        }
        this.worker = r.unwrap();
    }

    async init() {
        await this.loadWorker();
    }
}
</script>

<style lang='scss' scoped>

</style>
